
public class Set<X> {

	private Node<X> start;
	
	private int size;
	
	public Set() {
		this.start = null;
		this.size = 0;
	}
	
	public boolean isEmpty() {	
		if(size == 0) {	
			return true;		
		} else {		
			return false;
		}
	}
	
	public boolean contains(X wert) {
		
		Node<X> current = this.start;									
		while(current != null) {										
			
			if(current.wert == wert) {									
				return true;											
			}
			current = current.next; 									
			
		}
		return false;
			
	}
	
	public void add(X wert) {
		if(contains(wert) == false) {
			this.size++;											
			
			if(this.start == null) {							
				this.start = new Node<X>(wert);			
			} else { 
				Node<X> current = this.start;		
				while (current.next != null) {				
					current = current.next;	
	
				}
				current.next = new Node<X>(wert);
			}
			
		} else {
			return;
		}
		
	}
	
	public void remove(X wert) {
		Node<X> current = this.start;
		if(current.wert == wert) {
			this.start = current.next;
			size--;
		}
			while(current.next != null) {
				if(current.next.wert == wert) {
					current.next = current.next.next;
					size--;
				} else {
					current = current.next;
				}
			
			}
	}
	
	public Set<X> intersection(Set<X> s) {
		Set<X> result = new Set<X>();
		Node<X> current = this.start;
		while(current != null) {
			if(s.contains(current.wert)) result.add(current.wert);
			current = current.next;
		}
		return result;
	}
	
	//public Set<X> union(Set<X> s) {
		
	//}
	
	/*public Set<X> difference(Set<X> s) {
		
	}
	
	public Set<X> subset(Set<X> s) {
		
	} */
	
	public Node<X> getStart() { 
		return this.start;		
	}
	
	public int size() {	
		return this.size;	
	}
	
	public void Ausgabe() {
		Node<X> current = this.start;	
				
			while(current != null) {	
				System.out.print(current.wert + " ");	
				current = current.next;	
			} System.out.print("\n");
	}
	
}
